;*******************************************************************
;
;			SERRURE CODEE A TOUR
; oscillateur RC a 2.4 Mhz environ (10K, 22pF) 
;*******************************************************************
			list r=dec
			
			include "p16F84A.inc"

			__config	_WDT_OFF & _RC_OSC

			CBLOCK	0x0C
			TPO1, TPO2,TPO3,TPO4
			TOPS, CHRONO, CHRONOL
			OFFCOUNT
			DIGG, DIGD		; digits
			DIGG2, DIGD2	; digits saved
			WSAVE, SRSAVE
			FLAGS
			endc


#Define		GACH	PORTA,1		; ouverture ok

#Define		DIG_b	PORTA,2		; digit b
#Define		DIG_a	PORTA,3
#Define		DIG_f	PORTA,4
#Define		DIG_g	PORTB,3
#Define		DIG_e	PORTB,2
#Define		DIG_d	PORTB,1
#Define		DIG_c	PORTB,0

#Define		DIG_R	PORTA,0
#Define		DIG_L	PORTB,7

#Define		ENCOD_A		PORTB,5
#Define		ENCOD_B		PORTB,4
#Define		ENCOD_SW	PORTB,6
#Define		BUZZ		PORTB,6

#Define		K_1MIN		35

#Define		TOMBE		FLAGS,7		; =1 si mauvais chiffre entr !

;*************************************************************
; Definition des macros
;*************************************************************
BANK1       macro
    		bsf		STATUS,RP0
			endm
BANK0       macro
    		bcf		STATUS,RP0
			endm

;*************************************************************
; Vecteur de reset
;*************************************************************
			org		0
 			goto	start

;*************************************************************
; Vecteur d'interruption
;USE : TPO4
;*************************************************************
			org	4

intisr		movwf	WSAVE
			swapf	STATUS,0
			movwf	SRSAVE

;compteur chrono * K_1MIN
			decfsz	CHRONOL,1
			goto	_nodec
			movlw	K_1MIN
			movwf	CHRONOL
			decf	CHRONO,1		; decr le chrono de tops

			incf	OFFCOUNT,1		; inc compteur pour off mode

_nodec		btfss	DIG_R
			goto	metl
			bcf		DIG_R
			bsf		DIG_L
			movf	DIGD,0
			goto	finmet

metl		bsf		DIG_R
			bcf		DIG_L
			movf	DIGG,0

finmet		call	SETSEG

			bcf		INTCON,2
			bcf		INTCON,RBIF

			swapf   SRSAVE,0      ; remet STATUS
			movwf   STATUS
			swapf   WSAVE,1
			swapf   WSAVE,0       ; Remet W
			retfie

;.............................................................
; Debut du programme principal
;.............................................................
start  		BANK1
			movlw	00000000b
			movwf	TRISA
			movlw	01110000b
			movwf	TRISB
			BANK0

			bsf		GACH

			movlw	00000011b		; RBPU enabled, psa=1:16
			option

			movlw	10100000b
			movwf	INTCON

			movlw	K_1MIN		; (pour 1 min)
			movwf	CHRONOL		; raz compteur it
			clrf	OFFCOUNT

debut01		clrf	FLAGS		; raz flag si tomb
			movlw	1
			movwf	DIGD
			clrf	DIGG

debut0		clrf	EEADR		; raz le pointeur de code

; Test si time-out avant mode veille
debut		movf	OFFCOUNT,0
			xorlw	0xff		; pour 28 sec environ
			btfss	STATUS,Z
			goto	no_off
;Off-mode -> eteind les digits
			movf	DIGG,0
			movwf	DIGG2
			movf	DIGD,0
			movwf	DIGD2
			movlw	11
			movwf	DIGG
			movwf	DIGD
			movlw	0xff
			movwf	PORTA
			movwf	PORTB
			bsf		INTCON,RBIE
			sleep				; mode veille !
			nop
			bcf		INTCON,RBIE
			movf	DIGG2,0
			movwf	DIGG
			movf	DIGD2,0
			movwf	DIGD
			clrf	OFFCOUNT
			goto	debut01

; Fait le reglage d'un nombre +/- a l'encodeur,			
no_off		btfss	ENCOD_SW	; test appui sur SW
			goto	chkcod
			btfsc	ENCOD_A		; test deplacement
			goto	debut

scrut1		clrf	OFFCOUNT	; Raz le timer off mode
			btfsc	ENCOD_B		; teste le sens
			goto	droite

gauche		call	ANTIREB
			movf	DIGD,0
			btfsc	STATUS,Z
			goto	digd01
			decf	DIGD,1
			btfss	STATUS,Z
			goto	debut
			movf	DIGG,0
			btfss	STATUS,Z
			goto	debut
			movlw	9
			movwf	DIGD
			movwf	DIGG
			goto	debut
digd01		movlw	9
			movwf	DIGD
			decf	DIGG,1
			goto	debut

;Incremente simplement le nombre DIGG/DIGD
droite		call	ANTIREB
incrt		incf	DIGD,1		; sens +
			movf	DIGD,0
			xorlw	10
			btfss	STATUS,Z
			goto	debut
			clrf	DIGD
			incf	DIGG,1
			movf	DIGG,0
			xorlw	10
			btfss	STATUS,Z
			goto	debut
			call	CLIGNE00	; fait animation !
			goto	debut01		; -> debut & raz ptr de code

;...........................................................
;Teste si bon chiffre (apres appui sur SW uniquement)
chkcod		call	SW_TOP		; signal d'appui sur SW

			btfsc	TOMBE
			goto	debut		; -> si deja faux - sort 
			clrf	OFFCOUNT
			call	SETTOPS		; -> nb de tops dans TOPS

;Teste le nombre affich
			call	RD_E2		; lit eeprom
			xorwf	TOPS,0
			btfsc	STATUS,Z
			goto	tstouvre
			bsf		TOMBE		; signale faux !
			goto	debut

;teste si fin code ok (uniquement apres bon chiffre) 
tstouvre	incf	EEADR,1
			call	RD_E2		; lit eeprom
			xorlw	0
			btfss	STATUS,Z	; verifie le '0' de fin
			goto	debut		; sinon continue

;code fini et ok, on ouvre la porte...
ouvre		bcf		GACH		; ouvre la porte
			clrf	DIGG		; affiche signes 'On'
			movlw	14
			movwf	DIGD

;Teste si 5 appuis consecutifs pendant 2 sec
			movlw	8
			movwf	CHRONO
			movlw	K_1MIN
			movwf	CHRONOL
			clrf	TOPS

ouvr1		call	TEMP_
			call	TEMP_
			movf	CHRONO,0	; teste si time-out
			btfsc	STATUS,Z
			goto	finouvr
			btfsc	ENCOD_SW	; attend un front
			goto	ouvr1

ouvr12		call	TEMP_		; antireb sur SW
			btfss	ENCOD_SW
			goto	ouvr12

			incf	TOPS,1		; incr nombre de tops SW

ouvr2		movf	TOPS,0
			xorlw	5
			btfss	STATUS,Z
			goto	ouvr1
			
;Affiche le Mode reprogrammation du code
setcod		movlw	5
			movwf	DIGG		; affiche 'SC'
			movlw	12
			movwf	DIGD
			call	TEMPOL
			
;............................................................
;Commence a memoriser le nouveau code
stock0		movlw	1
			movwf	DIGD
			clrf	DIGG
			clrf	EEADR		; raz le pointeur de code

; Fait le reglage d'un nombre +/- a l'encodeur,
stock		btfss	ENCOD_SW	; test appui sur SW
			goto	domemo		; si appui SW -> memo		
	
			btfsc	ENCOD_A		; test deplacement
			goto	stock
			btfsc	ENCOD_B		; teste le sens
			goto	droite2

;sens a gauche detecte
gauche2		call	ANTIREB
decrt2		movf	DIGD,0
			btfsc	STATUS,Z
			goto	digd02
			decf	DIGD,1
			btfss	STATUS,Z
			goto	stock
			movf	DIGG,0
			btfss	STATUS,Z
			goto	stock
			goto	finmemo		; debordement -> fin memo
digd02		movlw	9
			movwf	DIGD
			decf	DIGG,1
			goto	stock
			
;Incremente simplement le nombre DIGG/DIGD
droite2		call	ANTIREB
incrt2		incf	DIGD,1		; sens +
			movf	DIGD,0
			xorlw	10
			btfss	STATUS,Z
			goto	stock
			clrf	DIGD
			incf	DIGG,1
			movf	DIGG,0
			xorlw	10
			btfss	STATUS,Z
			goto	stock
			goto	stock0		; debordement -> RAZ ptr
			
;Memorise le chiffre + '0' (apres appui SW uniquement)
domemo		call	SW_TOP		; signal top sw

			call	SETTOPS		; -> nb de tops dans TOPS
			movf	TOPS,0
			call	WR_E2		; save en eeprom
			incf	EEADR,1		; incr pointeur eeprom
			goto	stock

finmemo		movlw	0
			call	WR_E2		; save '0' de fin code

;Affiche le Mode reglage du temps d'ouverture
			movlw	13
			movwf	DIGG		; affiche 't1'
			movlw	1
			movwf	DIGD
			call	TEMPOL

;............................................................
;Reglage du temps et mode d'ouverture de t0  t9
;(t0 correspond au mode bistable)
modferm		btfss	ENCOD_SW	; test appui sur SW
			goto	domemo2		; si appui SW -> memo		
	
			btfsc	ENCOD_A		; teste si tourne
			goto	modferm
			btfsc	ENCOD_B		; teste le sens
			goto	droite3

;Sens - decremente simplement DIGD (9->0)
gauche3		call	ANTIREB
			movf	DIGD,0
			btfss	STATUS,Z
			decf	DIGD,1
			goto	modferm
			
;Sens + Incremente simplement le nombre DIGD
droite3		call	ANTIREB
			movf	DIGD,0
			xorlw	9
			btfss	STATUS,Z
			incf	DIGD,1
			goto	modferm
			
;Memorise le temps d'ouverture (apres appui SW)
domemo2		call	SW_TOP		; signal top sw
			movlw	63
			movwf	EEADR
			movf	DIGD,0
			call	WR_E2		; stocke DIGD en eeprom (63)

;Affiche validation de fin de reglage
			movlw	10
			movwf	DIGG		; affiche '--'
			movwf	DIGD
			call	TEMPOL
;............................................................
;Fait la bonne longueur d'ouverture avant de refermer 
finouvr		movlw	63
			movwf	EEADR
			call	RD_E2
			movwf	TOPS

			btfsc	STATUS,Z
			goto	domonost	; teste si monostable

doferm0		decf	TOPS,1
			btfsc	STATUS,Z
			goto	doferm
			call	TEMPOTL		; fait x fois 10 sec
			goto	doferm0

doferm		bsf		GACH		; referme la porte
			goto	debut01		; va faire next chiffre

;ouverture monostable jusqu'a rappui long sur SW
domonost	btfss	ENCOD_SW	; antireb SW
			goto	domonost
domost2		btfsc	ENCOD_SW	; attend appui SW
			goto	domost2
			call	TEMPOL
			btfsc	ENCOD_SW
			goto	domost2
domonost3	goto	doferm
;-----------------------------------------------------------
;Affiche un signal d'appui sur SW et antireb
SW_TOP		movf	DIGG,0
			movwf	DIGG2
			movf	DIGD,0
			movwf	DIGD2
			movlw	11			; affiche '  '
			movwf	DIGG
			movwf	DIGD
			call	TEMPO
			movf	DIGG2,0
			movwf	DIGG
			movf	DIGD2,0
			movwf	DIGD

antisw		btfss	ENCOD_SW	; anti rebond sw
			goto	SW_TOP
			return
;-------------------------------------------------------------
;Fait beep en attendant relachement (600Hz pendant 10mSec min) 
;USE : TPO1, TPO2
ANTIREB		movlw	15
  			movwf	TPO2

			BANK1
			movlw	00110000b	; BUZZ out
			movwf	TRISB
			BANK0

bz2			bcf		BUZZ
			call	TEMP_
			bsf		BUZZ
			call	TEMP_
			decfsz	TPO2,1
			goto	bz2

			BANK1
			movlw	01110000b	; BUZZ in
			movwf	TRISB
			BANK0

bz3			movlw	20
  			movwf	TPO2
bz4			call	TEMP_
			decfsz	TPO2,1
			goto	bz4

			btfss	ENCOD_A
			goto	bz3
			return
;----------------------------------------------------------
;Converti les digits DIGG/D en binaire dans TOPS
;USE : TPO1
SETTOPS		movf	DIGG,0
			movwf	TPO1

			movf	DIGD,0
			movwf	TOPS

sett1		movf	TPO1,0
			btfsc	STATUS,Z
			return

			movlw	10
			addwf	TOPS,1
			decf	TPO1,1
			goto	sett1
;----------------------------------------------------------
;Ecriture de l'eeprom et incremente EEADR
WR_E2		movwf	EEDATA
			bcf		INTCON,GIE
			
			BANK1
			bsf		EECON1,WREN
			movlw	0x55
			movwf	EECON2
			movlw	0xAA
			movwf	EECON2
			bsf		EECON1,WR

poll_ok		btfss	EECON1,EEIF
			goto	poll_ok
			bcf		EECON1,EEIF
			BANK0
			
			bsf		INTCON,GIE
			return

;Lecture de l'eeprom pointee, et incr. EEADR
RD_E2		bcf		INTCON,GIE
			BANK1
			bsf		EECON1,RD
			BANK0
			bsf		INTCON,GIE
			movf	EEDATA,0
			return

;**************************************************************
;Fait clignoter '00' en signe de reset code
;USE TPO1, TPO2, TPO3
CLIGNE00	movlw	10
			movwf	TPO3

clign2		clrf	DIGG
			clrf	DIGD
			call	TEMPO
			
			movlw	11
			movwf	DIGG
			movwf	DIGD
			call	TEMPO
			decfsz	TPO3,1
			goto	clign2
			return

;----------------------------------------------------------------
;Fait une tempo longue de 9.8 sec.
;USE TPO1, TPO2, TPO3
TEMPOTL		movlw	80
			movwf	TPO3
tptl1		call	TEMPO
			decfsz	TPO3,1
			goto	tptl1
			return

;Fait une tempo longue de 1,25 sec.
;USE TPO1, TPO2, TPO3
TEMPOL		movlw	10
			movwf	TPO3
clign1		call	TEMPO
			decfsz	TPO3,1
			goto	clign1
			return
;------------------------------------------------------------
;Tempo moyenne de 125 ms.
;USE : TPO1, TPO2
TEMPO		movlw	135
			movwf	TPO2
tl1			call	TEMP_
			call	TEMP_
			decfsz	TPO2,1
			goto	tl1
			return

;Tempo courte de 650uS
;USE : TPO1
TEMP_		movlw	90
			movwf	TPO1
tl2			decfsz	TPO1,1
			goto	tl2
			return
;**************************************************************
; Affichage du nombre sur 7 segments
;USE : TPO4
;**************************************************************
			org	0x200
SETSEG		movwf	TPO4
			movlw	2
			movwf	PCLATH

			movf	PORTA,0		; met a 0 les
			andlw	11100011b	; bits des segments
			movwf	PORTA
			movf	TPO4,0
			call	TAB7_A
			iorwf	PORTA,1

			movf	PORTB,0		; met a 0 les
			andlw	11110000b	; bits des segments
			movwf	PORTB
			movf	TPO4,0
			call	TAB7_B
			iorwf	PORTB,1
			return
			

TAB7_A		addwf	PCL,1		; table pour le port A
			retlw	00000000b	; 0
			retlw	00011000b	; 1
			retlw	00010000b	; 2
			retlw	00010000b	; 3
			retlw	00001000b	; 4
			retlw	00000100b	; 5
			retlw	00000100b	; 6
			retlw	00010000b	; 7
			retlw	00000000b	; 8
			retlw	00000000b	; 9
			retlw	00011100b	; 10 = '-'
			retlw	00011100b	; 11 = noir
			retlw	00000100b	; 12 = 'C'
			retlw	00001100b	; 13 = 'f'
			retlw	00011100b	; 14 = 'n'

TAB7_B		addwf	PCL,1		; table pour le port B
			retlw	00001000b	; 0
			retlw	00001110b	; 1
			retlw	00000001b	; 2
			retlw	00000100b	; 3
			retlw	00000110b	; 4
			retlw	00000100b	; 5
			retlw	00000000b	; 6
			retlw	00001110b	; 7
			retlw	00000000b	; 8
			retlw	00000100b	; 9
			retlw	00000111b	; 10 = '-'
			retlw	00001111b	; 11 = noir
			retlw	00001001b	; 12 = 'C'
			retlw	00000001b	; 13 = 'f'
			retlw	00000010b	; 14 = 'n'

;**************************************************************
; Definition du code initial en data-EEprom
;**************************************************************
			org	0x2100
			de		19, 6, 8, 0

			org	0x213f
			de		0			; pas de tempo d'ouverture !

			END
;**************************************************************
